Summary: MySQL: a very fast and reliable SQL database engine
Name: MySQL
%define mysql-version		3.22.7b-beta
%define shared_lib_version	4:0:0
%define release			1
%define mysqld-user		mysql
Version: %{mysql-version}
Release: %{release}
Copyright: MySQL FREE PUBLIC LICENSE (See the file PUBLIC)
Group: Applications/Databases
Source: http://www.tcx.se/Downloads/MySQL-3.22/mysql-%{mysql-version}.tar.gz
Icon: mysql.gif
URL: http://www.tcx.se/
Packager: David Axmark <david@tcx.se>
Provides: msqlormysql

BuildRoot:	/usr/src/redhat/INSTALL_ROOT

%description
MySQL is a true multi-user, multi-threaded SQL (Structured QuerynLanguage) database server. SQL is the most popular database languagenin the world. MySQL is a client/server implementation that consists ofna server daemon mysqld and many different client programs/libraries.nnThe main goals of MySQL are speed, robustness and easy to use.  MySQLnwas originally developed because we at Tcx needed a SQL server thatncould handle very big databases with magnitude higher speed than whatnany database vendor could offer to us. We have now been using MySQLnsince 1996 in a environment with more than 40 databases, 10,000ntables, of which more than 500 have more than 7 million rows. This isnabout 50G of mission critical data.nnThe base upon which MySQL is built is a set of routines that have beennused in a highly demanding production environment for manynyears. While MySQL is still in development, it already offers a richnand highly useful function set.nnSee the documentation for more information

%package client
Release: %{release}
Summary: MySQL - Client
Group: Applications/Databases

%description client
MySQL is a true multi-user, multi-threaded SQL (Structured QuerynLanguage) database server. SQL is the most popular database languagenin the world. MySQL is a client/server implementation that consists ofna server daemon mysqld and many different client programs/libraries.nnThe main goals of MySQL are speed, robustness and easy to use.  MySQLnwas originally developed because we at Tcx needed a SQL server thatncould handle very big databases with magnitude higher speed than whatnany database vendor could offer to us. We have now been using MySQLnsince 1996 in a environment with more than 40 databases, 10,000ntables, of which more than 500 have more than 7 million rows. This isnabout 50G of mission critical data.nnThe base upon which MySQL is built is a set of routines that have beennused in a highly demanding production environment for manynyears. While MySQL is still in development, it already offers a richnand highly useful function set.nnSee the documentation for more information

This package contains the standard MySQL clients.

%package bench
Release: %{release}
Requires: MySQL-client MySQL-DBI-perl-bin perl
Summary: MySQL - Benchmarks
Group: Applications/Databases

%description bench
MySQL is a true multi-user, multi-threaded SQL (Structured QuerynLanguage) database server. SQL is the most popular database languagenin the world. MySQL is a client/server implementation that consists ofna server daemon mysqld and many different client programs/libraries.nnThe main goals of MySQL are speed, robustness and easy to use.  MySQLnwas originally developed because we at Tcx needed a SQL server thatncould handle very big databases with magnitude higher speed than whatnany database vendor could offer to us. We have now been using MySQLnsince 1996 in a environment with more than 40 databases, 10,000ntables, of which more than 500 have more than 7 million rows. This isnabout 50G of mission critical data.nnThe base upon which MySQL is built is a set of routines that have beennused in a highly demanding production environment for manynyears. While MySQL is still in development, it already offers a richnand highly useful function set.nnSee the documentation for more information

This package contains MySQL benchmark scripts and data.

%package devel
Release: %{release}
Requires: MySQL MySQL-client
Summary: MySQL - Development header files and libraries
Group: Applications/Databases

%description devel
MySQL is a true multi-user, multi-threaded SQL (Structured QuerynLanguage) database server. SQL is the most popular database languagenin the world. MySQL is a client/server implementation that consists ofna server daemon mysqld and many different client programs/libraries.nnThe main goals of MySQL are speed, robustness and easy to use.  MySQLnwas originally developed because we at Tcx needed a SQL server thatncould handle very big databases with magnitude higher speed than whatnany database vendor could offer to us. We have now been using MySQLnsince 1996 in a environment with more than 40 databases, 10,000ntables, of which more than 500 have more than 7 million rows. This isnabout 50G of mission critical data.nnThe base upon which MySQL is built is a set of routines that have beennused in a highly demanding production environment for manynyears. While MySQL is still in development, it already offers a richnand highly useful function set.nnSee the documentation for more information

This package contains the development header files and libraries
necessary to develop MySQL client applications.

%prep
%setup -n mysql-%{mysql-version}

%build
# CFLAGS="-g -DEXTRA_DBUG" \ \
# CXXFLAGS="-g -DEXTRA_DBUG" \

# The all-static flag is to make the RPM work on different distributions.

sh -c  'PATH=/bin:/usr/bin \
	CC=gcc \
	CFLAGS="-O6 -fomit-frame-pointer"
	CXX=gcc \
	CXXFLAGS="-O6 -fomit-frame-pointer \
	          -felide-constructors -fno-rtti" \
	LDFLAGS="" \
	./configure \
	    --without-debug \
	    --enable-shared \
	    --with-pthread \
            --with-mysqld-user=%{mysqld-user} \
            --with-unix-socket-path=/var/lib/mysql/mysql.sock \
            --prefix=/ \
            --exec-prefix=/usr \
            --libexecdir=/usr/sbin \
            --sysconfdir=/etc \
            --datadir=/usr/share \
            --localstatedir=/var/lib/mysql \
            --infodir=/usr/info \
            --includedir=/usr/include \
            --mandir=/usr/man'
# benchdir does not fit in above model. Fix when we make a separate package
make benchdir=$RPM_BUILD_ROOT/usr/share/sql-bench

%install -n mysql-%{mysql-version}
RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/mysql-%{mysql-version}
if test -z "$RBR" -o "$RBR" = "/"
then
	echo "RPM_BUILD_ROOT has stupid value"
	exit 1
fi
rm -rf $RBR
# Ensure that needed directories exists
install -d $RBR/etc/{logrotate.d,rc.d/init.d}
install -d $RBR/var/lib/mysql/mysql
install -d $RBR/usr/share/sql-bench
install -d $RBR/usr/{sbin,share,man,include}
install -d $RBR/usr/doc/MySQL-%{mysql-version}
# Make install
make -d install DESTDIR=$RBR benchdir=/usr/share/sql-bench

# Install permission tables
for file in db.frm func.frm host.frm user.frm
do
  install -m644 $MBD/data/mysql/$file $RBR/var/lib/mysql/mysql/$file-new
done

# Install logrotate and autostart
install -m644 $MBD/support-files/mysql-log-rotate $RBR/etc/logrotate.d/mysql
install -m755 $MBD/support-files/mysql.server $RBR/etc/rc.d/init.d/mysql

# Install docs
install -m644 $RPM_BUILD_DIR/mysql-%{mysql-version}/Docs/mysql.info \
 $RBR/usr/info/mysql.info
for file in README PUBLIC Docs/manual_toc.html Docs/manual.html \
    Docs/manual.txt Docs/manual.texi Docs/manual.ps
do
    b=`basename $file`
    install -m644 $MBD/$file $RBR/usr/doc/MySQL-%{mysql-version}/$b
done

%pre
if test -x /usr/bin/mysqladmin
then
  if mysqladmin ping >/dev/null 2>&1
  then
    /etc/rc.d/init.d/mysql stop
    echo "Giving mysqld a couple of seconds to exit nicely"
    sleep 5
  fi
fi

%post
# We have a new shared library
/sbin/ldconfig
# Make MySQL start/shoutdown when the machine does it.
/sbin/chkconfig --add mysql
# Create a MySQL user
useradd -M -r -d /var/lib/mysql -s /bin/bash -c "MySQL server" mysql || true
# Initiate databases
mysql_install_db
# Shutdown MySQL to end default logging.
/etc/rc.d/init.d/mysql stop >/dev/null 2>&1
# Restart in the same way that mysqld will be started normally.
/etc/rc.d/init.d/mysql start >/dev/null 2>&1

%preun
if test -x /usr/bin/mysqladmin
then
  if mysqladmin ping >/dev/null 2>&1
  then
    /etc/rc.d/init.d/mysql stop
  fi
fi
if test $1 = 0
then
   /sbin/chkconfig --del mysql
fi

%postun
if [ $1 = 0 ]; then
  userdel mysql
  groupdel mysql
fi
/sbin/ldconfig

%files
%attr(-, root, root) %doc /usr/doc/MySQL-%{mysql-version}/

%attr(755, root, root) /usr/bin/add_file_priv
%attr(755, root, root) /usr/bin/add_func_table
%attr(755, root, root) /usr/bin/add_long_password
%attr(755, root, root) /usr/bin/isamchk
%attr(755, root, root) /usr/bin/isamlog
%attr(755, root, root) /usr/bin/mysql_install_db
%attr(755, root, root) /usr/bin/mysqlbug
%attr(755, root, root) /usr/bin/perror
%attr(755, root, root) /usr/bin/replace
%attr(755, root, root) /usr/bin/resolveip
%attr(755, root, root) /usr/bin/safe_mysqld
%attr(755, root, root) /usr/bin/mysql_zap

%attr(644, root, root) /usr/info/mysql.info

%attr(755, root, root) /usr/sbin/mysqld

%attr(644, root, root) /var/lib/mysql/mysql/db.frm-new
%attr(644, root, root) /var/lib/mysql/mysql/func.frm-new
%attr(644, root, root) /var/lib/mysql/mysql/host.frm-new
%attr(644, root, root) /var/lib/mysql/mysql/user.frm-new

%attr(644, root, root) /etc/logrotate.d/mysql
%attr(755, root, root) /etc/rc.d/init.d/mysql

%attr(755, root, root) /usr/share/mysql/

%files client
%attr(755, root, root) /usr/bin/msql2mysql
%attr(755, root, root) /usr/bin/mysql
%attr(755, root, root) /usr/bin/mysqlaccess
%attr(755, root, root) /usr/bin/mysqladmin
%attr(755, root, root) /usr/bin/mysqlbug
%attr(755, root, root) /usr/bin/mysqldump
%attr(755, root, root) /usr/bin/mysqlimport
%attr(755, root, root) /usr/bin/mysqlshow

%attr(644, root, man) %doc /usr/man/man1/mysql.1

%post client
/sbin/ldconfig

%files devel
%attr(644, root, root) /usr/include/mysql/
%attr(755, root, root) /usr/bin/comp_err
%attr(644, root, root) /usr/lib/mysql/libmysqlclient.a
%attr(644, root, root) /usr/lib/mysql/libmysqlclient.la

%files bench
%attr(-, root, root) /usr/share/sql-bench

%changelog

* Sun Aug 16 1998 David Axmark <david@detron.se>

- A developers changelog for MySQL is available in the source RPM. And
  there is a history of major user visible changed in the Reference Manual.
  Only RPM specific changes will be documented here.
